unit pnr1;
{
Public News Reader (C)1998 Paul Toth <tothpaul@mygale.org>
http://www.mygale.org/~tothpaul
http://ourworld.compuserve.com/HomePages/paultoth

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, urlmemo, GridList, ExtCtrls, ThrdSock, ComCtrls,
  D3split, Buttons, IniFiles;

type
  TForm1 = class(TForm)
    NNTP: TThrdNNTP;
    Panel1: TPanel;
    StatusBar: TStatusBar;
    MessageList: TGridList;
    Splitter1: TSplitter;
    Panel2: TPanel;
    MessageText: TURLMemo;
    Panel3: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    msgFrom: TLabel;
    msgSubject: TLabel;
    btCancel: TSpeedButton;
    btConnect: TSpeedButton;
    btDisconnect: TSpeedButton;
    Panel4: TPanel;
    ServerList: TComboBox;
    GroupList: TComboBox;
    btListGroup: TButton;
    Panel5: TPanel;
    btReply: TSpeedButton;
    btParent: TSpeedButton;
    procedure ServerListChange(Sender: TObject);
    procedure NNTPConnect(Sender: TObject);
    procedure NNTPGotList(Sender: TObject);
    procedure GroupListChange(Sender: TObject);
    procedure NNTPGroupStatus(Sender: TObject);
    procedure NNTPStatusChange(Sender: TObject);
    procedure NNTPHeader(Sender: TObject);
    procedure NNTPDisconnect(Sender: TObject);
    procedure MessageListClick(Sender: TObject);
    procedure NNTPBody(Sender: TObject);
    procedure NNTPArticle(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure NNTPBusy(Sender: TObject);
    procedure NNTPReady(Sender: TObject);
    procedure btConnectClick(Sender: TObject);
    procedure btDisconnectClick(Sender: TObject);
    procedure NNTPConnectFail(Sender: TObject);
    procedure btParentClick(Sender: TObject);
    procedure btListGroupClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btReplyClick(Sender: TObject);
  private
    { Dclarations prives }
    Article:integer;
    ReadCount:integer;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  Ini:TIniFile;

implementation

uses pnr2, pnr3;

{$R *.DFM}

procedure TForm1.ServerListChange(Sender: TObject);
begin
 NNTP.Disconnect;
 GroupList.Clear;
 MessageList.Clear;
 MessageText.Clear;
 Ini.ReadSection(ServerList.Text,GroupList.Items)
end;

procedure TForm1.NNTPConnect(Sender: TObject);
begin
 btConnect.Enabled:=False;
 btDisconnect.Enabled:=True;
 btListGroup.Enabled:=True;
// StatusBar.Panels[0].Text:='List groups...';
// NNTP.ListGroup;
end;

procedure TForm1.NNTPGotList(Sender: TObject);
var
 i:integer;
begin
 Form2.GroupList.Items.Assign(NNTP.Groups);
 For i:=0 to Form2.GroupList.Items.Count-1 do begin
  with Form2.GroupList do Checked[i]:=(GroupList.Items.IndexOf(Items[i])>=0);
 end;
 Form2.OK.Enabled:=True;
end;

procedure TForm1.GroupListChange(Sender: TObject);
begin
 MessageList.Clear;
 NNTP.Group:=GroupList.Text;
end;

procedure TForm1.NNTPGroupStatus(Sender: TObject);
begin
 StatusBar.Panels[0].Text:=Format('%d messages (from %d to %d)',[NNTP.Count,NNTP.First,NNTP.Last]);
 Article:=NNTP.Last;
 ReadCount:=0;
 if Article>0 then
  if not NNTP.GetHeader(Article) then showmessage('busy');
end;

procedure TForm1.NNTPStatusChange(Sender: TObject);
begin
 StatusBar.Panels[1].Text:=NNTP.Status;
end;

procedure TForm1.NNTPHeader(Sender: TObject);
begin
 with NNTP do MessageList.AddItem([Subject,From,Date,LineCount,MessageID]);
 inc(ReadCount);
 dec(Article);
 if (Article>=NNTP.First)and(ReadCount<100) then
  if not NNTP.GetHeader(Article) then showmessage('busy');
end;

procedure TForm1.NNTPDisconnect(Sender: TObject);
begin
 btListGroup.Enabled:=False;
 btDisconnect.Enabled:=False;
 btConnect.Enabled:=True;
 StatusBar.Panels[0].Text:='Ready.';
 StatusBar.Panels[1].Text:='Copyright(c) 1998, Paul TOTH <tothpaul@mygale.org>';
end;

procedure TForm1.MessageListClick(Sender: TObject);
begin
 NNTP.GetArticle(MessageList.Current[4]);
end;

procedure TForm1.NNTPBody(Sender: TObject);
begin
 MessageText.Lines.assign(NNTP.Lines);
end;

procedure TForm1.NNTPArticle(Sender: TObject);
begin
 msgFrom.Caption:=NNTP.From;
 msgSubject.Caption:=NNTP.Subject;
 MessageText.Lines.assign(NNTP.Lines);
 btParent.Enabled:=(NNTP.References.Count>0);
 btReply.Enabled:=True;
end;

procedure TForm1.btCancelClick(Sender: TObject);
begin
 NNTP.CancelRequest;
end;

procedure TForm1.NNTPBusy(Sender: TObject);
begin
 btCancel.Enabled:=true;
end;

procedure TForm1.NNTPReady(Sender: TObject);
begin
 btCancel.Enabled:=False;
end;

procedure TForm1.btConnectClick(Sender: TObject);
begin
 btConnect.Enabled:=false;
 StatusBar.Panels[0].Text:=ServerList.Text;
 NNTP.Server:=ServerList.Text;
 NNTP.Connect;
end;

procedure TForm1.btDisconnectClick(Sender: TObject);
begin
 NNTP.Disconnect;
end;

procedure TForm1.NNTPConnectFail(Sender: TObject);
begin
 btConnect.Enabled:=True;
end;

procedure TForm1.btParentClick(Sender: TObject);
begin
 NNTP.GetArticle(NNTP.References[0]);
end;

procedure TForm1.btListGroupClick(Sender: TObject);
var
 i:integer;
begin
 Form2:=TForm2.Create(Application);
 Try
  Form2.NNTP:=NNTP;
  Form2.ShowModal;
  Ini.ReadSection(NNTP.Server,GroupList.Items)
 Finally
  Form2.Free;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Ini:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.INI'));
end;

procedure TForm1.btReplyClick(Sender: TObject);
begin
 Form3:=TForm3.Create(Application);
 Try
  Form3.NNTP:=NNTP;
  Form3.ShowModal;
 Finally
  Form3.Free;
 end;
end;

end.
